unit libunpak;

interface

{$IFNDEF NO_DEFLATE}
function undeflate(dest: pbyte; destlen: plongword; const source: pbyte; sourcelen: plongword): integer;
{$ENDIF}

{$IFNDEF NO_PKWARE}
function unpkware(dest: pbyte; destlen: plongword; const source: pbyte; sourcelen: plongword): integer;
{$ENDIF}

implementation

{$IFNDEF NO_DEFLATE}
function puff(dest: pbyte; destlen: plongword; const source: pbyte; sourcelen: plongword): integer; cdecl; external;
{$L csources\puff}

function undeflate(dest: pbyte; destlen: plongword; const source: pbyte; sourcelen: plongword): integer;
begin
  result:=puff(dest, destlen, source, sourcelen);
end;
{$ENDIF}

{$IFNDEF NO_PKWARE}
function blast(infun: pointer; inhow: pbyte; outfun: pointer; outhow: pbyte; left: plongword; _in: pointer): integer; cdecl; external;
{$L csources\blast}

const
  CHUNK = 16384;

type
  tpack = packed record
    dptr: pbyte;
    dlen: longword;
  end;
  ppack = ^tpack;

function inf(how: ppack; var buf: pbyte): longword; cdecl;
begin
  if (how^.dlen >= CHUNK) then result:=CHUNK else result:=how^.dlen;
  how^.dlen:=how^.dlen - result;
  buf:=how^.dptr;
  inc(how^.dptr, result);
end;

function outf(how: ppack; buf: pbyte; len: longword): longword; cdecl;
begin
  if (how^.dptr = nil) then
  begin
    how^.dlen:=how^.dlen + len;
    result:=0;
  end
  else
  begin
    if (how^.dlen >= len) then result:=len else result:=how^.dlen;
    how^.dlen:=how^.dlen - result;
    move(buf^, how^.dptr^, result);
    inc(how^.dptr, result);
    result:=ord(result <> len);
  end;
end;

function unpkware(dest: pbyte; destlen: plongword; const source: pbyte; sourcelen: plongword): integer;
var
  din, dout: tpack;
  len: longword;
begin
  din.dptr:=source;
  din.dlen:=0;
  dout.dptr:=dest;
  dout.dlen:=0;
  if (sourcelen <> nil) then din.dlen:=sourcelen^;
  if (destlen <> nil) then dout.dlen:=destlen^;
  len:=0;
  result:=blast(@inf, @din, @outf, @dout, @len, nil);
  if (sourcelen <> nil) then sourcelen^:=sourcelen^ - din.dlen + len;
  if (destlen <> nil) then
  begin
    if (dest = nil) then destlen^:=dout.dlen
    else destlen^:=destlen^ - dout.dlen;
  end;
end;
{$ENDIF}

end.
